﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO.Ports;
using System.Reflection;
using Microsoft.Office.Interop.Excel; 



namespace Footpressuremeasurement
{
    public partial class Main_Form : Form
    {
        // create arrays of controls
        System.Windows.Forms.Label[] labelZone = new System.Windows.Forms.Label[4];
        PictureBox[] pbxZone4 = new PictureBox[5];
        PictureBox[] pbxZone3 = new PictureBox[5];
        PictureBox[] pbxZone2 = new PictureBox[5];
        PictureBox[] pbxZone1 = new PictureBox[5];

        public Main_Form()
        {
            InitializeComponent();  
            //declare events for serial port
            SerialInterface.myPort.DataReceived += new SerialDataReceivedEventHandler(PortDataRecieved);
            SerialInterface.myPort.ErrorReceived += new SerialErrorReceivedEventHandler(PortErrorRecieved);
            SerialInterface.myPort.PinChanged += new SerialPinChangedEventHandler(PortPinChanged);

            //create and initialize labels
            for (int i = 0; i < 4; i++)
            {
                this.labelZone[i] = new System.Windows.Forms.Label();
                this.labelZone[i].BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
                this.labelZone[i].Location = new System.Drawing.Point(81, 81 + i * 170);
                this.labelZone[i].Name = "lblZone" + (i + 1);
                this.labelZone[i].Size = new System.Drawing.Size(50, 27);
                this.labelZone[i].TabIndex = 27;
                this.labelZone[i].TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
                Controls.Add(labelZone[i]);
            }

            //create and initialize pictureboxes
            for (int j = 0; j < 5; j++)
            {
                this.pbxZone4[j] = new PictureBox();
                this.pbxZone4[j].BackColor = System.Drawing.Color.Transparent;
                this.pbxZone4[j].Location = new System.Drawing.Point(198, 546);
                this.pbxZone4[j].Name = "pbxHeel"+(j+1);
                this.pbxZone4[j].Size = new System.Drawing.Size(160, 184);
                this.pbxZone4[j].TabIndex = 19;
                this.pbxZone4[j].TabStop = false;

                this.pbxZone3[j] = new PictureBox();
                this.pbxZone3[j].BackColor = System.Drawing.Color.Transparent;
                this.pbxZone3[j].Location = new System.Drawing.Point(168, 351);
                this.pbxZone3[j].Name = "pbxOuterFoot"+(j+1);
                this.pbxZone3[j].Size = new System.Drawing.Size(98, 189);
                this.pbxZone3[j].TabIndex = 15;
                this.pbxZone3[j].TabStop = false;

                this.pbxZone2[j] = new PictureBox();
                this.pbxZone2[j].BackColor = System.Drawing.Color.Transparent;
                this.pbxZone2[j].Location = new System.Drawing.Point(168, 180);
                this.pbxZone2[j].Name = "pbxBall" + (j + 1);
                this.pbxZone2[j].Size = new System.Drawing.Size(246, 165);
                this.pbxZone2[j].TabIndex = 11;
                this.pbxZone2[j].TabStop = false;

                this.pbxZone1[j] = new PictureBox();
                this.pbxZone1[j].BackColor = System.Drawing.Color.Transparent;
                this.pbxZone1[j].Location = new System.Drawing.Point(166, 29);
                this.pbxZone1[j].Name = "pbxToes" + (j + 1);
                this.pbxZone1[j].Size = new System.Drawing.Size(258, 151);
                this.pbxZone1[j].TabIndex = 7;
                this.pbxZone1[j].TabStop = false;

                Controls.Add(pbxZone4[j]);
                Controls.Add(pbxZone3[j]);
                Controls.Add(pbxZone2[j]);
                Controls.Add(pbxZone1[j]);

            }
                // set resources for pictureboxes
                this.pbxZone4[0].Image = global::Footpressuremeasurement.Properties.Resources.Ferse_weiß;
                this.pbxZone4[1].Image = global::Footpressuremeasurement.Properties.Resources.Ferse_grün;
                this.pbxZone4[2].Image = global::Footpressuremeasurement.Properties.Resources.Ferse_gelb;
                this.pbxZone4[3].Image = global::Footpressuremeasurement.Properties.Resources.Ferse_orange;
                this.pbxZone4[4].Image = global::Footpressuremeasurement.Properties.Resources.Ferse_rot;

                this.pbxZone3[0].Image = global::Footpressuremeasurement.Properties.Resources.Aussenfuß_weiß;
                this.pbxZone3[1].Image = global::Footpressuremeasurement.Properties.Resources.Aussenfuß_grün;
                this.pbxZone3[2].Image = global::Footpressuremeasurement.Properties.Resources.Aussenfuß_gelb;
                this.pbxZone3[3].Image = global::Footpressuremeasurement.Properties.Resources.Aussenfuß_orange;
                this.pbxZone3[4].Image = global::Footpressuremeasurement.Properties.Resources.Aussenfuß_rot;

                this.pbxZone2[0].Image = global::Footpressuremeasurement.Properties.Resources.ballen_weiß;
                this.pbxZone2[1].Image = global::Footpressuremeasurement.Properties.Resources.ballen_grün;
                this.pbxZone2[2].Image = global::Footpressuremeasurement.Properties.Resources.ballen_gelb;
                this.pbxZone2[3].Image = global::Footpressuremeasurement.Properties.Resources.ballen_orange;
                this.pbxZone2[4].Image = global::Footpressuremeasurement.Properties.Resources.ballen_rot;

                this.pbxZone1[0].Image = global::Footpressuremeasurement.Properties.Resources.Zehen_weiß;
                this.pbxZone1[1].Image = global::Footpressuremeasurement.Properties.Resources.Zehen_grün;
                this.pbxZone1[2].Image = global::Footpressuremeasurement.Properties.Resources.Zehen_gelb;
                this.pbxZone1[3].Image = global::Footpressuremeasurement.Properties.Resources.Zehen_orange;
                this.pbxZone1[4].Image = global::Footpressuremeasurement.Properties.Resources.Zehen_rot;


        }


        // event pin changed
        void PortPinChanged(object sender, SerialPinChangedEventArgs e)
        {
            MessageBox.Show("pin got changed!");
        }

        //event error received
        void PortErrorRecieved(object sender, SerialErrorReceivedEventArgs e)
        {
            MessageBox.Show(string.Format("Error\n\n{0}", e.EventType));
        }

        //create variables
        String SerPortGeneral;
        String Zone1String;
        String Zone2String;
        String Zone3String;
        String Zone4String;

        static int STEP_COUNT=90;

        char[] Zone1Char= new char[4];
        char[] Zone2Char = new char[4];
        char[] Zone3Char = new char[4];
        char[] Zone4Char = new char[4];

        int[] Zone1Raw= new int[STEP_COUNT];
        int[] Zone2Raw= new int[STEP_COUNT];
        int[] Zone3Raw= new int[STEP_COUNT];
        int[] Zone4Raw= new int[STEP_COUNT];

        float[,] ZonePercent = new float[STEP_COUNT,4];
        
        int i = 0;
        int j = 0;
        int y = 0;
        int l = 0;

        //event for receiving data
        private void PortDataRecieved(object sender, SerialDataReceivedEventArgs e)
        {
            // read data
            SerPortGeneral= SerialInterface.myPort.ReadLine();

            // check which zone is send back
            if (SerPortGeneral[0] == 'Z')
            {
                if (SerPortGeneral[1] == '1')
                {
                    Zone1Char[0] = SerPortGeneral[2];
                    Zone1Char[1] = SerPortGeneral[3];
                    Zone1Char[2] = SerPortGeneral[4];
                    Zone1Char[3] = SerPortGeneral[5];
                    Zone1String = new string(Zone1Char);
                        if(i>=STEP_COUNT)
                        {
                            i = 0;
                        }
                        else
                        {
                            i++;
                        }
                    // save data in arrays
                    Zone1Raw[i] = Convert.ToInt16(Zone1String);
                    ZonePercent[i,0] = CalcZonePercent(Zone1Raw[i]);
                    // modify GUI
                    ColourZone(ZonePercent[i, 0], "Zone1");
                    labelZone[0].Text = Convert.ToString(ZonePercent[i, 0]);
                    
                }

                else if (SerPortGeneral[1] == '2')
                {
                    Zone2Char[0] = SerPortGeneral[2];
                    Zone2Char[1] = SerPortGeneral[3];
                    Zone2Char[2] = SerPortGeneral[4];
                    Zone2Char[3] = SerPortGeneral[5];
                    Zone2String = new string(Zone2Char);
                        if (j >= STEP_COUNT)
                        {
                            j = 0;
                        }
                        else
                        {
                            j++;
                        }
                    // save data in arrays
                    Zone2Raw[j] = Convert.ToInt16(Zone2String);
                    ZonePercent[j,1] = CalcZonePercent(Zone2Raw[j]);
                    // modify GUI
                    ColourZone(ZonePercent[j, 1], "Zone2");
                    labelZone[1].Text = Convert.ToString(ZonePercent[j, 1]);

                }
                else if (SerPortGeneral[1] == '3')
                {
                    Zone3Char[0] = SerPortGeneral[2];
                    Zone3Char[1] = SerPortGeneral[3];
                    Zone3Char[2] = SerPortGeneral[4];
                    Zone3Char[3] = SerPortGeneral[5];
                    Zone3String = new string(Zone3Char);
                        if (y >= STEP_COUNT)
                        {
                            y = 0;
                        }
                        else
                        {
                            y++;
                        }
                    // save data in arrays
                    Zone3Raw[y] = Convert.ToInt16(Zone3String);
                    ZonePercent[y,2] = CalcZonePercent(Zone3Raw[y]);
                    // modify GUI
                    ColourZone(ZonePercent[y, 2], "Zone3");
                    labelZone[2].Text = Convert.ToString(ZonePercent[y, 2]);

                }
                else if (SerPortGeneral[1] == '4')
                {
                    Zone4Char[0] = SerPortGeneral[2];
                    Zone4Char[1] = SerPortGeneral[3];
                    Zone4Char[2] = SerPortGeneral[4];
                    Zone4Char[3] = SerPortGeneral[5];
                    Zone4String = new string(Zone4Char);
                         if (l >= STEP_COUNT)
                         {
                             l = 0;
                         }
                         else
                         {
                            l++;
                         }
                    // save data in arrays
                    Zone4Raw[l] = Convert.ToInt16(Zone4String);
                    ZonePercent[l,3] = CalcZonePercent(Zone4Raw[l]);
                    // modify GUI
                    ColourZone(ZonePercent[l, 3], "Zone4");
                    labelZone[3].Text = Convert.ToString(ZonePercent[l, 3]);
                    //synchronize zones
                        if (l != y || l != j || l != i)
                        {
                            y = l;
                            j = l;
                            i = l;
                        }
                }
            }
        }

        // method for requesting zones
        public void Sendrequest(string Zone)
        {
            if (SerialInterface.myPort.IsOpen == true)
            {
                if (Zone == "Zone1")
                    SerialInterface.myPort.Write("Z1\n");
                if (Zone == "Zone2")
                    SerialInterface.myPort.Write("Z2\n");
                if (Zone == "Zone3")
                    SerialInterface.myPort.Write("Z3\n");
                if (Zone == "Zone4")
                    SerialInterface.myPort.Write("Z4\n");

            }
            else
            {
                SerialInterface.myPort.Open();
                if (Zone == "Zone1")
                    SerialInterface.myPort.Write("Z1\n");
                if (Zone == "Zone2")
                    SerialInterface.myPort.Write("Z2\n");
                if (Zone == "Zone3")
                    SerialInterface.myPort.Write("Z3\n");
                if (Zone == "Zone4")
                    SerialInterface.myPort.Write("Z4\n");
            }
        }

        // method for calculating relativ values of straint
        public float CalcZonePercent(int ZoneAtTime)
        {
            float ZonePercent;
            int ZoneMaximium=0;
            // check for new maximum
            if (ZoneMaximium < ZoneAtTime)
            {
                ZoneMaximium = ZoneAtTime;
            }
            // calculate percent
            ZonePercent = (ZoneMaximium / 100) * ZoneAtTime;
            return ZonePercent;
        }

        //method for setting the limiting values for each colour
        public void ColourZone(float Percent, string Zone)
        {
            if (Percent == 0)
            {
                AddColour(Zone, 0);
            }
            if (Percent > 0 && Percent < 26)
            {
                AddColour(Zone, 1);
            }
            if (Percent > 25 && Percent < 46)
            {
                AddColour(Zone, 2);
            }
            if (Percent > 45 && Percent < 76)
            {
                AddColour(Zone, 3);
            }
            if (Percent > 75 && Percent < 101)
            {
                AddColour(Zone, 4);
            }
        }
        // method for colouring zones
        public void AddColour(String Zone, int ColourNr)
        {
            if (Zone == "Zone4")
            {
                if (ColourNr >= 0 && ColourNr <= 4)
                {
                    pbxZone4[ColourNr].BringToFront();
                }
            }
            if (Zone == "Zone3")
            {
                if (ColourNr >= 0 && ColourNr <= 4)
                {
                    pbxZone3[ColourNr].BringToFront();
                }
            }
            if (Zone == "Zone2")
            {
                if (ColourNr >= 0 && ColourNr <= 4)
                {
                    pbxZone2[ColourNr].BringToFront();
                }
            }
            if (Zone == "Zone1")
            {
                if (ColourNr >= 0 && ColourNr <= 4)
                {
                    pbxZone1[ColourNr].BringToFront();
                }
            }
        }

        // timer used to request data
        private void Timer_T_Tick(object sender, EventArgs e)
        {
            Sendrequest("Zone1");
            Sendrequest("Zone2");
            Sendrequest("Zone3");
            Sendrequest("Zone4");
        }

        // button start event
        private void btnStart_Click(object sender, EventArgs e)
        {
            Timer_T.Start();
        }
        // button pause event
        private void btnPause_Click(object sender, EventArgs e)
        {
            Timer_T.Stop();
        }


        // start when the export button is clicked
        private void btnExport_Click(object sender, EventArgs e)
        {
            // declare Excelobjects: Excel application, Workbook, Worksheet, range
            Microsoft.Office.Interop.Excel.Application Excelmain;
            Microsoft.Office.Interop.Excel._Workbook ExcelWorkbook;
            Microsoft.Office.Interop.Excel._Worksheet ExcelSheet;
            Microsoft.Office.Interop.Excel.Range ExcelRange;
                // create Excelobjects
                Excelmain = new Microsoft.Office.Interop.Excel.Application();
		        Excelmain.Visible = true;

                ExcelWorkbook = (Microsoft.Office.Interop.Excel._Workbook)(Excelmain.Workbooks.Add(Missing.Value));
                ExcelSheet = (Microsoft.Office.Interop.Excel._Worksheet)ExcelWorkbook.ActiveSheet;

                // create headers of worksheet
		        ExcelSheet.Cells[1, 1] = "Zone 1";
		        ExcelSheet.Cells[1, 2] = "Zone 2";
		        ExcelSheet.Cells[1, 3] = "Zone 3";
		        ExcelSheet.Cells[1, 4] = "Zone 4";
                ExcelSheet.Cells[1, 5] = "Zone 1 in %";
                ExcelSheet.Cells[1, 6] = "Zone 2 in %";
                ExcelSheet.Cells[1, 7] = "Zone 3 in %";
                ExcelSheet.Cells[1, 8] = "Zone 4 in %";
                
                // set format for headers
		        ExcelSheet.get_Range("A1", "H1").Font.Bold = true;
                ExcelSheet.get_Range("A1", "H1").VerticalAlignment = Microsoft.Office.Interop.Excel.XlVAlign.xlVAlignCenter;

                // set data to fill worksheet
                ExcelSheet.get_Range("A2", "A" + (STEP_COUNT + 1)).Value2 = Zone1Raw;
                ExcelSheet.get_Range("B2", "B" + (STEP_COUNT + 1)).Value2 = Zone2Raw;
                ExcelSheet.get_Range("C2", "C" + (STEP_COUNT + 1)).Value2 = Zone3Raw;
                ExcelSheet.get_Range("D2", "D" + (STEP_COUNT + 1)).Value2 = Zone4Raw;
                ExcelSheet.get_Range("E2", "H" + (STEP_COUNT + 1)).Value2 = ZonePercent;

                // set format  
		        ExcelRange = ExcelSheet.get_Range("A1", "H1");
		        ExcelRange.EntireColumn.AutoFit();

		        // use method to draw chart
		        DisplayChart(ExcelSheet);
                
                // make application visible and allow user control
		        Excelmain.Visible = true;
		        Excelmain.UserControl = true;

        }

        private void DisplayChart(Microsoft.Office.Interop.Excel._Worksheet ExcelWS)
        {
            // declare objects
            Microsoft.Office.Interop.Excel._Workbook ExcelWB;
	        Microsoft.Office.Interop.Excel.Series ExcelSeries;
            Microsoft.Office.Interop.Excel.Range ChartRange;
            Microsoft.Office.Interop.Excel._Chart ExcelChart;

	        // add chart for the selected data.
            ExcelWB = (Microsoft.Office.Interop.Excel._Workbook)ExcelWS.Parent;
            ExcelChart = (Microsoft.Office.Interop.Excel._Chart)ExcelWB.Charts.Add(Missing.Value, Missing.Value, Missing.Value, Missing.Value);

            // set source for the chart
            ChartRange = ExcelWS.get_Range("E2:H" + (STEP_COUNT + 1), Missing.Value);

            // create chart using ChartWizard
            ExcelChart.ChartWizard(ChartRange, XlChartType.xlLine , 4,
             XlRowCol.xlColumns, System.Type.Missing, System.Type.Missing, true, "Gradient of Pressure ",
             "chronological sequence", "pressure in %", System.Type.Missing);

            // name Series
            ExcelSeries = (Microsoft.Office.Interop.Excel.Series)ExcelChart.SeriesCollection(1);
            for (int u = 1; u <=4; u++)
            {
                ExcelSeries = (Microsoft.Office.Interop.Excel.Series)ExcelChart.SeriesCollection(u);
                String seriesName;
                seriesName = "Zone "+ u;
                ExcelSeries.Name = seriesName;
            }          

  
            ExcelChart.Location(Microsoft.Office.Interop.Excel.XlChartLocation.xlLocationAsObject, ExcelWS.Name);

	        //set location of chart
            ChartRange = (Microsoft.Office.Interop.Excel.Range)ExcelWS.Rows.get_Item(10, Missing.Value);
            ExcelWS.Shapes.Item("Chart 1").Top = (float)(double)ChartRange.Top;
            ChartRange = (Microsoft.Office.Interop.Excel.Range)ExcelWS.Columns.get_Item(10, Missing.Value);
            ExcelWS.Shapes.Item("Chart 1").Left = (float)(double)ChartRange.Left;
 
        }





    }
}